Attribute VB_Name = "modCdlDialog"
Option Explicit
Private Declare Function CHOOSECOLOR Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Type CHOOSECOLOR
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lplngCustColors As String
    flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Public bytCustomColors() As Byte 'ffentlich, da sie immer in einer Prozedur neu deklariert werden mssen.
Dim typOPENFILEDim As OPENFILENAME


Public Function ShowOpenSave(lnghWnd As Long, blnShowOpen As Boolean, Optional blnShowIcon As Boolean = False) As String

    With typOPENFILEDim
        .lStructSize = Len(typOPENFILEDim)
        .hwndOwner = lnghWnd
        .hInstance = App.hInstance
        If (blnShowOpen) Then
            '### Filter fr den ffnen Dialog
            .lpstrFilter = "Untersttzte Dateien" + Chr$(0) + "*.bmp;*.gif;*.jpg;*.jpeg;*.ico;*.wmf;*.cur" + Chr$(0) + _
            "Bitmap Dateien (*.bmp)" + Chr$(0) + "*.bmp" + Chr$(0) + _
            "Compuserve Gif Dateien (*.gif)" + Chr$(0) + "*.gif" + Chr$(0) + _
            "Cursor Dateien (*.cur)" + Chr$(0) + "*.cur" + Chr$(0) + _
            "Icon Dateien (*.ico)" + Chr$(0) + "*.ico" + Chr$(0) + _
            "JPEG Dateien (*.jp(e)g)" + Chr$(0) + "*.jpg;*.jpeg" + Chr$(0) + _
            "Metafile Dateien (*.wmf)" + Chr$(0) + "*.wmf" + Chr$(0) + _
            "Alle Dateien (*.*)" + Chr$(0) + "*.*" + Chr$(0)
            '### ///
        Else
            .lpstrFilter = "Bitmap Datei (*.bmp)" + Chr$(0) + "*.bmp"
        End If
        If (blnShowIcon) Then .lpstrFilter = "Icon Datei (*.ico)" + Chr$(0) + "*.ico"
        .lpstrFile = Space$(254)
        .nMaxFile = 255
        .lpstrFileTitle = Space$(254)
        .nMaxFileTitle = 255
        .lpstrInitialDir = "C:\"
        IIf blnShowOpen, .lpstrTitle = "Grafikdatei ffnen", .lpstrTitle = "Grafikdatei ffnen"
        .flags = &H4 'Das der Schreibschutz-Anzeiger nicht angezeigt wird.
    End With
    
    If (blnShowOpen) Then
        If GetOpenFileName(typOPENFILEDim) Then
            ShowOpenSave = Trim$(typOPENFILEDim.lpstrFile)
        Else
            ShowOpenSave = ""
        End If
    Else
        If GetSaveFileName(typOPENFILEDim) Then
            ShowOpenSave = Trim$(typOPENFILEDim.lpstrFile)
        Else
            ShowOpenSave = ""
        End If
    End If
    
End Function

Public Function ShowColor(lnghWnd As Long) As Long

    Dim typCHOOSECOLORDim As CHOOSECOLOR
    Dim lngCustColor(16) As Long
    Dim lngReturn As Long

    typCHOOSECOLORDim.lStructSize = Len(typCHOOSECOLORDim)
    typCHOOSECOLORDim.hwndOwner = lnghWnd
    typCHOOSECOLORDim.hInstance = App.hInstance
    typCHOOSECOLORDim.lplngCustColors = StrConv(bytCustomColors, vbUnicode)
    typCHOOSECOLORDim.flags = 0

    If CHOOSECOLOR(typCHOOSECOLORDim) <> 0 Then
        ShowColor = typCHOOSECOLORDim.rgbResult
        bytCustomColors = StrConv(typCHOOSECOLORDim.lplngCustColors, vbFromUnicode)
    Else
        ShowColor = -1
    End If
End Function

